/*
 * Copyright (c) 2002, ERIK WISTRAND
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice, 
 *   this list of conditions and the following disclaimer. 
 * 
 * - Redistributions in binary form must reproduce the above copyright notice, 
 *   this list of conditions and the following disclaimer in the documentation 
 *   and/or other materials provided with the distribution. 
 * 
 * - Neither the name of the VALENTINE MIDLET PROJECT nor the names of its 
 *   contributors may be used to endorse or promote products derived 
 *   from this software without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package com.wistrand.midlet.valentine;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

import java.util.*;

import com.wistrand.midlet.sprite.*;
import com.wistrand.midlet.fp.*;


/**
 * Bouncer class
 */
public class Bouncer {

  /** Minimum value */

  int min;
  int max;

  int sum      = 0;
  int count    = 0;
  int meanY    = 0;
  int maxCount = 10;

  int delta;

  /** The value */
  int val;
  
  /** gravitation */
  int grav;

  /** delta value when hittong max value */ 
  int bounce = 0;

  public Bouncer(int val, int delta, int min, int max, int grav) {
    this.val   = val;
    this.delta = delta;
    this.min   = min;
    this.max   = max;
    this.grav  = grav;
  }
  
  public void update() {
    delta = delta + grav;

    count++;
    sum += val;
    
    meanY = sum / count;
    if(count > maxCount) {
      sum   = val;
      count = 1;
    }

    val += delta;

    if(val < min) { delta = -delta; val = min; }
    
    if(val > max) { 
      delta = -delta; val = max; 
      if(delta < 0) { 
	bounce = delta;
      } 
    }

    //    System.out.println("bouncer y=" + y + ", delta=" + delta);
  }

  public int getBounce() {
    int i =  bounce;
    bounce = 0;
    return i;
  }

  public int getValue() {
    return val;
  }
}

